//+------------------------------------------------------------------+
//|                                             One more average.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers    4
#property indicator_color1     DeepSkyBlue
#property indicator_color2     Red
#property indicator_color3     Yellow
#property indicator_color4     Orange
#property indicator_width1     2
#property indicator_level1     0
#property indicator_levelcolor DimGray


//
//
//
//
//

extern int    FastLength      = 100;
extern int    FastPrice       = PRICE_CLOSE;
extern double FastSpeed       = 8.0;
extern int    SlowLength      = 4000;
extern int    SlowPrice       = PRICE_CLOSE;
extern double SlowSpeed       = 1.0;
extern bool   Adaptive        = true;
extern int    SignalLength1   = 500;
extern double SignalSpeed1    = 1.0;
extern bool   AdaptiveSignal1 = true;
extern int    SignalLength2   = 800;
extern double SignalSpeed2    = 1.0;
extern bool   AdaptiveSignal2 = true;
extern int    SignalLength3   = 1000;
extern double SignalSpeed3    = 1.0;
extern bool   AdaptiveSignal3 = true;

//
//
//
//
//

double macd[];
double signal1[];
double signal2[];
double signal3[];
double stored[][35];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
      SetIndexBuffer(0,macd);
      SetIndexBuffer(1,signal1);
      SetIndexBuffer(2,signal2);
      SetIndexBuffer(3,signal3);
      
         FastLength    = MathMax(FastLength,1);
         SlowLength    = MathMax(SlowLength,1);
         SignalLength1 = MathMax(SignalLength1,1);
         SignalLength2 = MathMax(SignalLength2,1);
         SignalLength3 = MathMax(SignalLength3,1);
         FastSpeed     = MathMax(FastSpeed,-1.5);
         SlowSpeed     = MathMax(SlowSpeed,-1.5);
         SignalSpeed1  = MathMax(SignalSpeed1,-1.5);
         SignalSpeed2  = MathMax(SignalSpeed2,-1.5);
         SignalSpeed3  = MathMax(SignalSpeed3,-1.5);
         
   IndicatorShortName("One more average ("+FastLength+","+SlowLength+")");
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;
         if (ArrayRange(stored,0) != Bars) ArrayResize(stored,Bars);

   //
   //
   //
   //
   //

   for(i=limit, r=Bars-limit-1; i>=0; i--,r++)
   {
      double fastOma = iAverage(iMA(NULL,0,1,0,MODE_SMA,FastPrice,i),FastLength,FastSpeed,Adaptive,r,0);
      double slowOma = iAverage(iMA(NULL,0,1,0,MODE_SMA,SlowPrice,i),SlowLength,SlowSpeed,Adaptive,r,7);
      
            macd[i]  = fastOma - slowOma;
      
           signal1[i] = iAverage(macd[i],SignalLength1,SignalSpeed1,AdaptiveSignal1,r,14);
           signal2[i] = iAverage(macd[i],SignalLength2,SignalSpeed2,AdaptiveSignal2,r,21);
           signal3[i] = iAverage(macd[i],SignalLength3,SignalSpeed3,AdaptiveSignal3,r,28);
   }      
   return(0);
}

 

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define E1  0
#define E2  1
#define E3  2
#define E4  3
#define E5  4
#define E6  5
#define res 6

//
//
//
//
//

double iAverage(double price, double averagePeriod, double tconst, bool adaptive, int r, int ashift=0)
{
   double e1=stored[r-1][E1+ashift];  double e2=stored[r-1][E2+ashift];
   double e3=stored[r-1][E3+ashift];  double e4=stored[r-1][E4+ashift];
   double e5=stored[r-1][E5+ashift];  double e6=stored[r-1][E6+ashift];

   //
   //
   //
   //
   //

      if (adaptive && (averagePeriod > 1))
      {
         double minPeriod = averagePeriod/2.0;
         double maxPeriod = minPeriod*5.0;
         int    endPeriod = MathCeil(maxPeriod);
         double signal    = MathAbs((price-stored[r-endPeriod][res]));
         double noise     = 0.00000000001;

            for(int k=1; k<endPeriod; k++) noise=noise+MathAbs(price-stored[r-k][res]);

         averagePeriod = ((signal/noise)*(maxPeriod-minPeriod))+minPeriod;
      }
      
      //
      //
      //
      //
      //
      
      double alpha = (2.0+tconst)/(1.0+tconst+averagePeriod);

      e1 = e1 + alpha*(price-e1); e2 = e2 + alpha*(e1-e2); double v1 = 1.5 * e1 - 0.5 * e2;
      e3 = e3 + alpha*(v1   -e3); e4 = e4 + alpha*(e3-e4); double v2 = 1.5 * e3 - 0.5 * e4;
      e5 = e5 + alpha*(v2   -e5); e6 = e6 + alpha*(e5-e6); double v3 = 1.5 * e5 - 0.5 * e6;

   //
   //
   //
   //
   //

   stored[r][E1+ashift]  = e1;  stored[r][E2+ashift] = e2;
   stored[r][E3+ashift]  = e3;  stored[r][E4+ashift] = e4;
   stored[r][E5+ashift]  = e5;  stored[r][E6+ashift] = e6;
   stored[r][res+ashift] = price;
   return(v3);
}